Index: trunk/src/VBox/VMM/VMMAll/PGMAllBth.h
===================================================================
--- trunk/src/VBox/VMM/VMMAll/PGMAllBth.h	(revision 9039)
+++ trunk/src/VBox/VMM/VMMAll/PGMAllBth.h	(revision 9041)
@@ -78,5 +78,5 @@
 PGM_BTH_DECL(int, Trap0eHandler)(PVM pVM, RTGCUINT uErr, PCPUMCTXCORE pRegFrame, RTGCPTR pvFault)
 {
-#if (PGM_GST_TYPE == PGM_TYPE_32BIT || PGM_GST_TYPE == PGM_TYPE_REAL || PGM_GST_TYPE == PGM_TYPE_PROT || PGM_GST_TYPE == PGM_TYPE_PAE || PGM_GST_TYPE == PGM_TYPE_AMD64) \
+#if   (PGM_GST_TYPE == PGM_TYPE_32BIT || PGM_GST_TYPE == PGM_TYPE_REAL || PGM_GST_TYPE == PGM_TYPE_PROT || PGM_GST_TYPE == PGM_TYPE_PAE || PGM_GST_TYPE == PGM_TYPE_AMD64) \
     && PGM_SHW_TYPE != PGM_TYPE_NESTED
 
@@ -565,5 +565,5 @@
             else
             {
-                /* When the guest accesses invalid physical memory (e.g. probing of RAM or accessing a remapped MMIO range), then we'll fall 
+                /* When the guest accesses invalid physical memory (e.g. probing of RAM or accessing a remapped MMIO range), then we'll fall
                  * back to the recompiler to emulate the instruction.
                  */
@@ -1418,6 +1418,6 @@
     LogFlow(("SyncPage: GCPtrPage=%VGv cPages=%d uErr=%#x\n", GCPtrPage, cPages, uErr));
 
-#if    (PGM_GST_TYPE == PGM_TYPE_32BIT \
-    ||  PGM_GST_TYPE == PGM_TYPE_PAE) \
+#if    (   PGM_GST_TYPE == PGM_TYPE_32BIT \
+        || PGM_GST_TYPE == PGM_TYPE_PAE) \
     && PGM_SHW_TYPE != PGM_TYPE_NESTED
 
@@ -1662,5 +1662,5 @@
 
 #elif (PGM_GST_TYPE == PGM_TYPE_REAL || PGM_GST_TYPE == PGM_TYPE_PROT) \
-      && PGM_SHW_TYPE != PGM_TYPE_NESTED
+    && PGM_SHW_TYPE != PGM_TYPE_NESTED
 
 # ifdef PGM_SYNC_N_PAGES
@@ -2028,5 +2028,5 @@
 
 UpperLevelPageFault:
-    /* Pagefault detected while checking the PML4E, PDPE or PDE. 
+    /* Pagefault detected while checking the PML4E, PDPE or PDE.
      * Single exit handler to get rid of duplicate code paths.
      */
@@ -2037,5 +2037,5 @@
     LogFlow(("CheckPageFault: real page fault at %VGv (%d)\n", GCPtrPage, uPageFaultLevel));
 
-    if (    
+    if (
 #  if PGM_GST_TYPE == PGM_TYPE_AMD64
             pPml4eSrc->n.u1Present &&
@@ -2523,5 +2523,5 @@
 PGM_BTH_DECL(int, PrefetchPage)(PVM pVM, RTGCUINTPTR GCPtrPage)
 {
-#if (PGM_GST_TYPE == PGM_TYPE_32BIT || PGM_GST_TYPE == PGM_TYPE_REAL || PGM_GST_TYPE == PGM_TYPE_PROT || PGM_GST_TYPE == PGM_TYPE_PAE) \
+#if   (PGM_GST_TYPE == PGM_TYPE_32BIT || PGM_GST_TYPE == PGM_TYPE_REAL || PGM_GST_TYPE == PGM_TYPE_PROT || PGM_GST_TYPE == PGM_TYPE_PAE) \
     && PGM_SHW_TYPE != PGM_TYPE_AMD64 && PGM_SHW_TYPE != PGM_TYPE_NESTED
     /*
@@ -2603,5 +2603,5 @@
 
     Assert(!HWACCMIsNestedPagingActive(pVM));
-#if (PGM_GST_TYPE == PGM_TYPE_32BIT ||  PGM_GST_TYPE == PGM_TYPE_REAL ||  PGM_GST_TYPE == PGM_TYPE_PROT || PGM_GST_TYPE == PGM_TYPE_PAE) \
+#if   (PGM_GST_TYPE == PGM_TYPE_32BIT ||  PGM_GST_TYPE == PGM_TYPE_REAL ||  PGM_GST_TYPE == PGM_TYPE_PROT || PGM_GST_TYPE == PGM_TYPE_PAE) \
     && PGM_SHW_TYPE != PGM_TYPE_AMD64 && PGM_SHW_TYPE != PGM_TYPE_NESTED
 
@@ -2760,8 +2760,9 @@
 {
 #if PGM_SHW_TYPE == PGM_TYPE_NESTED
-    /* @todo check if this is really necessary */
+    /** @todo check if this is really necessary */
     HWACCMFlushTLB(pVM);
     return VINF_SUCCESS;
-#else
+
+#else /* PGM_SHW_TYPE != PGM_TYPE_NESTED */
     if (VM_FF_ISSET(pVM, VM_FF_PGM_SYNC_CR3))
         fGlobal = true; /* Change this CR3 reload to be a global one. */
@@ -2780,5 +2781,5 @@
     STAM_PROFILE_STOP(&pVM->pgm.s.CTXMID(Stat,SyncCR3Handlers), h);
 
-#ifdef PGMPOOL_WITH_MONITORING
+# ifdef PGMPOOL_WITH_MONITORING
     /*
      * When monitoring shadowed pages, we reset the modification counters on CR3 sync.
@@ -2791,18 +2792,18 @@
     else
     {
-# ifdef IN_RING3
+#  ifdef IN_RING3
         pVM->pgm.s.fSyncFlags &= ~PGM_SYNC_CLEAR_PGM_POOL;
         pgmPoolClearAll(pVM);
-# else
+#  else
         LogFlow(("SyncCR3: PGM_SYNC_CLEAR_PGM_POOL is set -> VINF_PGM_SYNC_CR3\n"));
         return VINF_PGM_SYNC_CR3;
-# endif
-    }
-#endif
+#  endif
+    }
+# endif
 
     Assert(fGlobal || (cr4 & X86_CR4_PGE));
     MY_STAM_COUNTER_INC(fGlobal ? &pVM->pgm.s.CTXMID(Stat,SyncCR3Global) : &pVM->pgm.s.CTXMID(Stat,SyncCR3NotGlobal));
 
-#if PGM_GST_TYPE == PGM_TYPE_32BIT || PGM_GST_TYPE == PGM_TYPE_PAE
+# if PGM_GST_TYPE == PGM_TYPE_32BIT || PGM_GST_TYPE == PGM_TYPE_PAE
     /*
      * Get page directory addresses.
@@ -2863,5 +2864,5 @@
                 for (unsigned iPD = 0; iPD < ELEMENTS(pPDSrc->a); iPD++)
                 {
-                    if (   pPDEDst[iPD].n.u1Present 
+                    if (   pPDEDst[iPD].n.u1Present
                         && !(pPDEDst[iPD].u & PGM_PDFLAGS_MAPPING))
                     {
@@ -3023,9 +3024,9 @@
                 }
             }
-#   if PGM_GST_TYPE == PGM_TYPE_PAE
+#  if PGM_GST_TYPE == PGM_TYPE_PAE
             else if (iPD + iPDPTE * X86_PG_PAE_ENTRIES != iPdNoMapping)
-#   else
+#  else
             else if (iPD != iPdNoMapping)
-#   endif
+#  endif
             {
                 /*