Index: trunk/src/VBox/Frontends/VirtualBox/include/VBoxConsoleView.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/include/VBoxConsoleView.h	(revision 9047)
+++ trunk/src/VBox/Frontends/VirtualBox/include/VBoxConsoleView.h	(revision 9048)
@@ -240,5 +240,5 @@
     bool mAutoresizeGuest : 1;
 
-    bool mIsAdditionsActive : 1;
+    bool mGuestSupportsGraphics : 1;
 
     bool mNumLock : 1;
Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxConsoleView.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxConsoleView.cpp	(revision 9047)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxConsoleView.cpp	(revision 9048)
@@ -629,5 +629,5 @@
     , mIgnoreMainwndResize (true)
     , mAutoresizeGuest (false)
-    , mIsAdditionsActive (false)
+    , mGuestSupportsGraphics (false)
     , mNumLock (false)
     , mScrollLock (false)
@@ -997,5 +997,5 @@
         maybeRestrictMinimumSize();
 
-        if (mIsAdditionsActive && mAutoresizeGuest)
+        if (mGuestSupportsGraphics && mAutoresizeGuest)
             doResizeHint();
     }
@@ -1200,5 +1200,5 @@
                 LogFlowFunc (("AdditionsStateChangeEventType\n"));
 
-                mIsAdditionsActive = ge->additionActive();
+                mGuestSupportsGraphics = ge->supportsGraphics();
 
                 maybeRestrictMinimumSize();
@@ -1555,5 +1555,5 @@
             {
                 if (!mIgnoreMainwndResize &&
-                    mIsAdditionsActive && mAutoresizeGuest)
+                    mGuestSupportsGraphics && mAutoresizeGuest)
                     resize_hint_timer->start (300, TRUE);
                 break;
@@ -2244,5 +2244,5 @@
 void VBoxConsoleView::toggleFSMode (const QSize &aSize)
 {
-    if ((mIsAdditionsActive && mAutoresizeGuest) ||
+    if ((mGuestSupportsGraphics && mAutoresizeGuest) ||
         mMainWnd->isTrueFullscreen())
     {
@@ -2286,5 +2286,5 @@
 bool VBoxConsoleView::isAutoresizeGuestActive()
 {
-    return mIsAdditionsActive && mAutoresizeGuest;
+    return mGuestSupportsGraphics && mAutoresizeGuest;
 }
 
@@ -3545,5 +3545,5 @@
 void VBoxConsoleView::doResizeHint (const QSize &aToSize)
 {
-    if ((mIsAdditionsActive && mAutoresizeGuest) ||
+    if ((mGuestSupportsGraphics && mAutoresizeGuest) ||
         mMainWnd->isTrueFullscreen())
     {
@@ -3654,5 +3654,5 @@
     if (mode == VBoxDefs::SDLMode)
     {
-        if (!mIsAdditionsActive || !mAutoresizeGuest)
+        if (!mGuestSupportsGraphics || !mAutoresizeGuest)
             setMinimumSize (sizeHint());
         else
Index: trunk/src/VBox/Frontends/VirtualBox4/include/VBoxConsoleView.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/include/VBoxConsoleView.h	(revision 9047)
+++ trunk/src/VBox/Frontends/VirtualBox4/include/VBoxConsoleView.h	(revision 9048)
@@ -258,5 +258,5 @@
     bool mAutoresizeGuest : 1;
 
-    bool mIsAdditionsActive : 1;
+    bool mGuestSupportsGraphics : 1;
 
     bool mNumLock : 1;
Index: trunk/src/VBox/Frontends/VirtualBox4/src/VBoxConsoleView.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/src/VBoxConsoleView.cpp	(revision 9047)
+++ trunk/src/VBox/Frontends/VirtualBox4/src/VBoxConsoleView.cpp	(revision 9048)
@@ -650,5 +650,5 @@
     , mIgnoreMainwndResize (true)
     , mAutoresizeGuest (false)
-    , mIsAdditionsActive (false)
+    , mGuestSupportsGraphics (false)
     , mNumLock (false)
     , mScrollLock (false)
@@ -1032,5 +1032,5 @@
         maybeRestrictMinimumSize();
 
-        if (mIsAdditionsActive && mAutoresizeGuest)
+        if (mGuestSupportsGraphics && mAutoresizeGuest)
             doResizeHint();
     }
@@ -1248,5 +1248,5 @@
                 LogFlowFunc (("AdditionsStateChangeEventType\n"));
 
-                mIsAdditionsActive = ge->additionActive();
+                mGuestSupportsGraphics = ge->supportsGraphics();
 
                 maybeRestrictMinimumSize();
@@ -1602,5 +1602,5 @@
             {
                 if (!mIgnoreMainwndResize &&
-                    mIsAdditionsActive && mAutoresizeGuest)
+                    mGuestSupportsGraphics && mAutoresizeGuest)
                     QTimer::singleShot (300, this, SLOT (doResizeHint()));
                 break;
@@ -2284,5 +2284,5 @@
 void VBoxConsoleView::toggleFSMode()
 {
-    if ((mIsAdditionsActive && mAutoresizeGuest) ||
+    if ((mGuestSupportsGraphics && mAutoresizeGuest) ||
         mMainWnd->isTrueFullscreen())
     {
@@ -2303,5 +2303,5 @@
      * feature disabled". 100 msec pause required for resizing
      * before normalizing geometry. */
-    mToggleFSModeTimer->start (mIsAdditionsActive && mAutoresizeGuest ?
+    mToggleFSModeTimer->start (mGuestSupportsGraphics && mAutoresizeGuest ?
         2000 : 100);
 
@@ -2337,5 +2337,5 @@
 bool VBoxConsoleView::isAutoresizeGuestActive()
 {
-    return mIsAdditionsActive && mAutoresizeGuest;
+    return mGuestSupportsGraphics && mAutoresizeGuest;
 }
 
@@ -3574,5 +3574,5 @@
 void VBoxConsoleView::doResizeHint (const QSize &aToSize)
 {
-    if ((mIsAdditionsActive && mAutoresizeGuest) ||
+    if ((mGuestSupportsGraphics && mAutoresizeGuest) ||
         mMainWnd->isTrueFullscreen())
     {
@@ -3683,5 +3683,5 @@
     if (mode == VBoxDefs::SDLMode)
     {
-        if (!mIsAdditionsActive || !mAutoresizeGuest)
+        if (!mGuestSupportsGraphics || !mAutoresizeGuest)
             setMinimumSize (sizeHint());
         else