Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxConsoleView.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxConsoleView.cpp	(revision 9069)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxConsoleView.cpp	(revision 9070)
@@ -998,5 +998,5 @@
         maybeRestrictMinimumSize();
 
-        if (mGuestSupportsGraphics && mAutoresizeGuest)
+        if (mAutoresizeGuest)
             doResizeHint();
     }
@@ -1558,6 +1558,5 @@
                  * when (and only when) the autoresize property is "true". */
                 mDoResize = mGuestSupportsGraphics || mMainWnd->isTrueFullscreen();
-                if (!mIgnoreMainwndResize &&
-                    mGuestSupportsGraphics && mAutoresizeGuest)
+                if (!mIgnoreMainwndResize && mAutoresizeGuest)
                     resize_hint_timer->start (300, TRUE);
                 break;
@@ -2248,6 +2247,5 @@
 void VBoxConsoleView::toggleFSMode (const QSize &aSize)
 {
-    if ((mGuestSupportsGraphics && mAutoresizeGuest) ||
-        mMainWnd->isTrueFullscreen())
+    if (mAutoresizeGuest || mMainWnd->isTrueFullscreen())
     {
         QSize newSize;
@@ -2290,5 +2288,5 @@
 bool VBoxConsoleView::isAutoresizeGuestActive()
 {
-    return mGuestSupportsGraphics && mAutoresizeGuest;
+    return mAutoresizeGuest;
 }
 
@@ -3549,5 +3547,5 @@
 void VBoxConsoleView::doResizeHint (const QSize &aToSize)
 {
-    if (mGuestSupportsGraphics && mAutoresizeGuest)
+    if (mAutoresizeGuest)
     {
         /* If this slot is invoked directly then use the passed size
@@ -3667,5 +3665,5 @@
     if (mode == VBoxDefs::SDLMode)
     {
-        if (!mGuestSupportsGraphics || !mAutoresizeGuest)
+        if (!mAutoresizeGuest)
             setMinimumSize (sizeHint());
         else
Index: trunk/src/VBox/Frontends/VirtualBox4/src/VBoxConsoleView.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox4/src/VBoxConsoleView.cpp	(revision 9069)
+++ trunk/src/VBox/Frontends/VirtualBox4/src/VBoxConsoleView.cpp	(revision 9070)
@@ -1033,5 +1033,5 @@
         maybeRestrictMinimumSize();
 
-        if (mGuestSupportsGraphics && mAutoresizeGuest)
+        if (mAutoresizeGuest)
             doResizeHint();
     }
@@ -1605,6 +1605,5 @@
                  * when (and only when) the autoresize property is "true". */
                 mDoResize = mGuestSupportsGraphics || mMainWnd->isTrueFullscreen();
-                if (!mIgnoreMainwndResize &&
-                    mGuestSupportsGraphics && mAutoresizeGuest)
+                if (!mIgnoreMainwndResize && mAutoresizeGuest)
                     QTimer::singleShot (300, this, SLOT (doResizeHint()));
                 break;
@@ -2288,6 +2287,5 @@
 void VBoxConsoleView::toggleFSMode()
 {
-    if ((mGuestSupportsGraphics && mAutoresizeGuest) ||
-        mMainWnd->isTrueFullscreen())
+    if (mAutoresizeGuest || mMainWnd->isTrueFullscreen())
     {
         QSize newSize = QSize();
@@ -2301,12 +2299,10 @@
         doResizeHint (newSize);
     }
-    /* Currently there is 2000 msec pause before timer transfers
-     * console into desired mode "if GA are active and auto-resize
-     * feature enabled" and 100 msec pause before it transfers
-     * console into this mode "if GA are not active or auto-resize
-     * feature disabled". 100 msec pause required for resizing
+    /* Currently there is a 2000 msec pause before timer transfers
+     * console into desired mode if the auto-resize feature is enabled
+     * and a 100 msec pause before it transfers console into this mode
+     * if it is not enabled. 100 msec pause required for resizing
      * before normalizing geometry. */
-    mToggleFSModeTimer->start (mGuestSupportsGraphics && mAutoresizeGuest ?
-        2000 : 100);
+    mToggleFSModeTimer->start (mAutoresizeGuest ? 2000 : 100);
 
     /// @todo (r=dsen) perform roll-back after 'entering' mode in case
@@ -2341,5 +2337,5 @@
 bool VBoxConsoleView::isAutoresizeGuestActive()
 {
-    return mGuestSupportsGraphics && mAutoresizeGuest;
+    return mAutoresizeGuest;
 }
 
@@ -3592,5 +3588,5 @@
 void VBoxConsoleView::doResizeHint (const QSize &aToSize)
 {
-    if (mGuestSupportsGraphics && mAutoresizeGuest)
+    if (mAutoresizeGuest)
     {
         /* If this slot is invoked directly then use the passed size
@@ -3710,5 +3706,5 @@
     if (mode == VBoxDefs::SDLMode)
     {
-        if (!mGuestSupportsGraphics || !mAutoresizeGuest)
+        if (!mAutoresizeGuest)
             setMinimumSize (sizeHint());
         else